''' 变量锁 '''


import asyncio


class varlock():
    
    def __init__(self, sleep=1):
        self.__pipe = [None]
        self.__sleep = sleep
    
    async def getlock(self):
        while True:
            try:
                self.__pipe.pop(0)
                return True
            except IndexError:
                await asyncio.sleep(self.__sleep)
            except Exception as e:
                raise e
    
    def givelock(self):
        self.__pipe = [None]
        return True

    async def __aenter__(self):
        await self.getlock()
        return True

    async def __aexit__(self, exc_type, exc_val, exc_tb):
        self.givelock()
